![pipeline](https://code.usgs.gov/ghsc/nshmp/nshmp-lib/badges/master/pipeline.svg)
![coverage](https://code.usgs.gov/ghsc/nshmp/nshmp-lib/badges/master/coverage.svg)

This project loosely adheres to [Google Java Style](https://google.github.io/styleguide/javaguide.html) and is informed by [Effective Java](http://en.wikipedia.org/wiki/Joshua_Bloch#Effective_Java). All source files and documentation are encoded using [UTF-8](https://en.wikipedia.org/?title=UTF-8). Developers should also consider the following:

* Line lengths:
    * code: __100__, but shorter is better.
    * comments: __80__, for readability.
* Use unicode symbols where possible: `double μ = 0.4;`
* Use static imports for only the most common utilities and preconditions:
    * `java.lang.math`
    * `com.google.common.base.Preconditions`

### Dependencies

The following are required to build and run *nshmp-haz*. Additional testing a code coverage dependencies are listed in the [license](/usgs/nshmp-haz/blob/master/LICENSE.md).

1. [Java 11 JDK](https://www.oracle.com/java/technologies/javase-jdk11-downloads.html)
2. [Guava](http://code.google.com/p/guava-libraries/)
3. [Gson](https://code.google.com/p/google-gson/)
