package gov.usgs.earthquake.nshmp.model;

import static org.junit.jupiter.api.Assertions.assertThrows;

import java.nio.file.Path;
import java.nio.file.Paths;

import org.junit.jupiter.api.Test;

public class LoaderTests {

  /*
   * These tests ensure that the basic model structure is in place. Model
   * components (e.g. model-config.json, gmm-tree.json) are tested by their
   * respective deserializing classes.
   */

  static final Path RESOURCES = Paths.get("src/test/resources/model");

  static final Path MODEL_NO_INFO = RESOURCES.resolve("model-no-info");
  // static final Path MODEL_NO_CONFIG = RESOURCES.resolve("model-no-config");
  // static final Path MODEL_NO_SOURCE_DIRS =
  // RESOURCES.resolve("model-no-source-dirs");
  static final Path MODEL_NO_GMM_TREE = RESOURCES.resolve("model-no-gmm-tree");
  static final Path MODEL_NO_SOURCES = RESOURCES.resolve("model-no-sources");

  static final Path MODEL_MINIMUM = RESOURCES.resolve("model-minimum");
  // static final Path MODEL_OVERRIDES = RESOURCES.resolve("model-overrides");

  // @Test
  // public void testMinimumModel() throws Exception {
  // HazardModel model = Loader.load(MODEL_OVERRIDES);
  // assertEquals(0, model.size());
  // }

  // @Test
  // public void testModelOverrides() throws Exception {
  // HazardModel model = Loader.load(MODEL_OVERRIDES);
  // // test optional calc-config overrides truncationLevel
  // assertEquals(2.0, model.config().hazard.truncationLevel);
  // // TODO test source-config overrides point source field
  // // currently source config is lost after being used to init sources
  // // not sure how to test success.
  // }

  @Test
  void loadTests() throws Exception {

    assertThrows(NullPointerException.class, () -> {
      ModelLoader.load(null);
    });

    /*
     * For NoSuchFileExceptions we check the message for the file name as the
     * exception itself is ambiguous as to the actual file that is missing.
     */

    /* Expected model-info. */
    // Exception e1 = assertThrows(NoSuchFileException.class, () -> {
    // ModelLoaderOld.load(MODEL_NO_INFO);
    // });
    // assertTrue(e1.getMessage().endsWith(ModelLoaderOld.MODEL_INFO));

    /* Expected source-config. */
    // Exception e2 = assertThrows(NoSuchFileException.class, () -> {
    // Loader.load(MODEL_NO_CONFIG);
    // });
    // assertTrue(e2.getMessage().endsWith(Loader.SOURCE_CONFIG));

    // /* Test source-config present, but no source directories. */
    // assertThrows(IllegalStateException.class, () -> {
    // Loader.load(MODEL_NO_SOURCE_DIRS);
    // });

    /* Test gmm-tree missing from source directory. */
    // Exception e3 = assertThrows(NoSuchElementException.class, () -> {
    // ModelLoaderOld.load(MODEL_NO_GMM_TREE);
    // });

    // assertTrue(e3.getMessage().endsWith(Loader.GMM_TREE));

    // TODO switch statements are entered but successful overrides are not
    // checked

    // TODO re-enable along with HazardModel.Builder.build() empty state check
    /* Test empty model; also tests overrides. */
    // assertThrows(IllegalStateException.class, () -> {
    // Loader.load(MODEL_NO_SOURCES);
    // });

  }

  // TODO test MODEL_NO_INFO_DATA

  // @Test
  // public void testLoadSourceDirectory() throws Exception {
  // Loader.load(MODEL_CALC_CONFIG)
  // assertThrows(IllegalStateException.class, () -> {
  // Loader.load(MODEL_CALC_CONFIG);
  // });
  // }

  /*
   * This test drops through to a system exit call. Not sure what to do. Do we
   * care enough?
   */
  // @Test
  // public void testEmptyModel() throws Exception {
  // exception.expect(IllegalStateException.class);
  // URL emptyURL = Resources.getResource(LoaderTests.class, BAD_FOLDER);
  // Loader.load(Paths.get(emptyURL.getPath()));
  // }

  // public static void main(String[] args) throws Exception {
  // URL emptyURL = Resources.getResource(LoaderTests.class, BAD_FOLDER);
  // Loader.load(Paths.get(emptyURL.getPath()));
  //
  // }

  // Problems with model structure

}
